<?php
// ファイル屋さん標準関数

function chkDownloadEnable($fileName,$coupon)
{
	global $gSys;
	if(''==trim($coupon))
		return false;
	if(!file_exists($gSys['dir']['data'].$fileName))
		return false;
	$fp = @fopen($gSys['dir']['log'].'dl_allow.log', "r");
	if ($fp) {
		while (!feof($fp)) {
			$lines = fgetcsv($fp, 4096, "\t");
			if($coupon==$lines[0]){
				if($gSys['sys']['dl_ip_check'])	// ip一致の確認が必要という設定であれば
					if($_SERVER['REMOTE_ADDR']!=$lines[7])	// ipの一致を確認
						return false;
				return true;
			}
		}
		fclose($fp);
	}
	return false;
}

function getDownloadAllowRecord($coupon)
{
	global $gSys;
	if(''==trim($coupon))
		return false;
	$fp = @fopen($gSys['dir']['log'].'dl_allow.log', "r");
	if ($fp) {
		while (!feof($fp)) {
			$lines = fgetcsv($fp, 4096, "\t");
			if($coupon==$lines[0]){
				if($gSys['sys']['dl_ip_check'])	// ip一致の確認が必要という設定であれば
					if($_SERVER['REMOTE_ADDR']!=$lines[7])	// ipの一致を確認
						return false;
				return $lines;
			}
		}
		fclose($fp);
	}
	return false;
}


// 秒を○日○時間○分○秒になおす
function secondFormat($sec)
{
	$disp='';
	if($sec > (24*60*60)){
		$disp.=(string)(integer)($sec/(24*60*60));
		$disp.='日';
		$sec=(integer)($sec%(24*60*60));
	}
	if($sec > (60*60)){
		$disp.=(string)(integer)($sec/(60*60));
		$disp.='時間';
		$sec=(integer)($sec%(60*60));
	}else{
//		if($disp!='')
//			$disp.='0時間';
	}
	if($sec > (60)){
		$disp.=(string)(integer)($sec/(60));
		$disp.='分';
		$sec=(integer)($sec%(60));
	}else{
//		if($disp!='')
//			$disp.='0分';
	}
	if($sec!=0){
		$disp.=(string)$sec.'秒';
	}else{
		if($disp=='')
			$disp.='0秒';
	}
	return $disp;
}

function exFileLock($fileName)
{
	$fp = fopen($fileName, "r");
	if (!flock($fp, LOCK_EX)) { // 排他的ロックを行う
	    echo "Couldn't lock the file !";
	}
	return $fp;
}
function exFileUnlock($fp)
{
	flock($fp, LOCK_UN); // ロックを解放する
	fclose($fp);
}

function loadFileList()
{
	global $gSys;
	
	$listDataSrc=file_get_contents($gSys['dir']['data'].'filelist.txt');
	$listLines=explode("\n",$listDataSrc);
	$fileListData='';
	foreach($listLines as $line){
		// 先頭に;でスキップ
		if(';'==substr($line,0,1))
			continue;
		if(''==trim($line))
			continue;
		$fields=explode("\t",$line);
		$tmpFileField='';
		$tmpFileField=array(
			'filename' => trim($fields[0]),
			'price' => trim($fields[1]),
			'title' => trim($fields[2]),
			'description' => trim($fields[3])
			);
		$fileListData[trim($fields[0])]=$tmpFileField;
	}
	return $fileListData;
}

function listDataDir($fileListData='')
{
	global $gSys;
	if(''==$fileListData)
		$fileListData=loadFileList();
	$fileList='';
	$d = dir($gSys['dir']['data']);
	while (false !== ($entry = $d->read())) {
		$entry=trim($entry);
		if($entry=='')
			continue;
		if($entry=='filelist.txt')
			continue;
		if(ereg('/',$entry))
			continue;
		if(ereg('\.\.',$entry))
			continue;
		if(ereg('^[\.]+$',$entry))
			continue;
		// ファイル一覧にデータが存在しないのでスキップ
		if(!is_array($fileListData[$entry]))
			continue;
		$fileList[]=$entry;
	}
	$d->close();
	
	return $fileList;
}
function genFileListHtml()
{
	global $gSys;
//print_r($gSys['in']['cookie']);
//print_r($_COOKIE);
//print('test');
	$fileListData=loadFileList();
	$fileList =& listDataDir($fileListData);
	$fileListHtml='';
	foreach($fileListData as $f)
	{
		if(!in_array($f['filename'],$fileList))
			continue;
		$isDownloadable=false;
		$downloadText='';
		$isTrade = false;
		// cookie を チェックして、ダウンロード済かどうか表示
		if(is_array($gSys['in']['cookie']['trade_filename'])){
			if($gSys['in']['cookie']['trade_filename'][$f['filename']] != ''){
				$tradeText = '【購入済】';
				$isTrade = true;
				// ダウンロード可能かどうかチェック
				if(chkDownloadEnable($f['filename'],$gSys['in']['cookie']['trade_filename'][$f['filename']])){
					$isDownloadable=true;
				}
			}else{
				$tradeText = '';
				$isTrade = false;
			}
		}
		if($isTrade and $isDownloadable){
			$downloadText='【ダウンロード可能】';
			// ダウンロードリンク
			$link = $gSys['config']['store_index_url'].'?p=view/download&filename='.$f['filename'].'&coupon='.$gSys['in']['cookie']['trade_filename'][$f['filename']];
		}else{
			// 購入リンク
			$link = $gSys['config']['store_index_url'].'?p=view/detail&filename='.$f['filename'];
		}
		$fileListHtml.='<li class="contents_item_list_li">'.$tradeText.$downloadText.'<a href="'.$link.'">'.
			$f['title'].
			'</a>'.
			'('.number_format($f['price']).'モリタポ)'.
			' '.$f['description'].
			'</li>';
	}
	return $fileListHtml;
}

function getFileDetailData($fileName)
{
	global $gSys;
	$fileDataSet=array();
	
	$fileName=ereg_replace('/','',$fileName);
	$fileFullPath=$gSys['dir']['data'].$fileName;
	$fileListData=loadFileList();
	$fileDataSet=&$fileListData[$fileName];
	
	$fileDataSet['md5']=md5_file($fileFullPath);
	$fileDataSet['size']=filesize($fileFullPath);
	$fileDataSet['mod_time_ut']=filemtime($fileFullPath);
	$fileDataSet['mod_time']=date("Y/m/d H:i:s",filemtime($fileFullPath));

	return $fileDataSet;
}

?>
